// -------------- DirectX hooking example using the G4Mhook SDK -----------------
//
// This example combines the FiberThread hook method with the DirectX hooking 
// functionality. You'll need to install and set-up the directX SDK to compile
// this example. In order to reduce dependencies you should compile with the
// March 2008 DirectX SDK, as it is the version used by GTA IV. We also provide a
// better way to handle input, through the use of SetWindowsHookEx().
//
// --------------------- bean_xp - modmygta.com - 2009 --------------------------

#include <windows.h>
#include <d3d9.h>

#include "CustomFiberThread.h"

#include "../ScriptHook/ScriptHookManager.h"
#include "../ScriptHook/Log.h"
#include "../ScriptHook/LoggerFile.h"

CustomFiberThread _customThread;

// Declaration of our methods we would like to add to the hook
void DXHookInitialize(IDirect3DDevice9* m_device, D3DPRESENT_PARAMETERS* pPresentationParameters);
void DXHookRender(IDirect3DDevice9* m_device);
void DXHookReset();

HMODULE hDLL;

BOOL APIENTRY DllMain( HMODULE hModule, DWORD  fdwReason, LPVOID lpReserved)
{
    switch (fdwReason)
    {
        case DLL_PROCESS_ATTACH: 
        {
			DisableThreadLibraryCalls(hModule);

			// Store this for later, so we can load resources embedded in the dll
			hDLL = hModule;

			// Setup the scripthook/fiberthread as usual
			ScriptHookManager::RegisterThread( &_customThread );

			// Add our DirectX methods to the hook
			ScriptHookManager::RegisterDirectXHook(&DXHookInitialize, &DXHookRender, &DXHookReset);

            break;
        }
    }

    return TRUE;
}